/*
 * SLListElement.java
 *
 * Copyright  Paul Pinault, Disk91 2003.
 *
 * Tout dtenteur d'une copie de ce programme et des fichiers de 
 * documentation associs (le  logiciel ) bnficie des droits 
 * d'exploitation, de copie, de modification, de rutilisation, de 
 * publication, de distribution gratuite ou commerciale, et reste libre 
 * de distribuer l'ensemble et/ou d'en vendre des copies en octroyant ces 
 * mmes droits aux utilisateurs sous rserve de signaler son utilisation 
 *  son auteur par mail, indiquant votre identit et le nom de votre 
 * projet,  l'adresse suivante : dpl@disk91.com, ce signalement implique 
 * de votre part un accord d'utilisation de ces informations dans le but de 
 * promouvoir le dit logiciel. En outre, les droit sont accords sous 
 * rserve d'inclure le copyright ci-dessus et l'avertissement suivant dans 
 * toute copie, totale ou partielle, du programme :
 *
 * CE PROGRAMME EST FOURNI  TEL QU'EN L'TAT , SANS AUCUNE GARANTIE DE 
 * QUELQUE NATURE, IMPLICITE OU EXPLICITE, QUANT  SON UTILISATION 
 * COMMERCIALE, PROFESSIONNELLE, LGALE OU NON, OU AUTRE. L'AUTEUR NE PEUT 
 * EN AUCUN CAS TRE TENU POUR RESPONSABLE DE QUELQUE DOMMAGE OU PRJUDICE 
 * DIRECT, INDIRECT, SECONDAIRE OU ACCESSOIRE DCOULANT DE L'UTILISATION DE 
 * TOUT OU PARTIE DE CE PROGRAMME.
 *
 * Les noms Paul Pianult et  Disk91 ne saurait tre utilis dans le but 
 * de promouvoir ou de lgitimer un produit driv de ce programme sans 
 * autorisation crite pralable  cette effet.
 *
 * Created on 10 juillet 2003, 11:25
 */

package disk.tools.sllist;

/**
 * Element d'une liste doublement chaine, contient un objet, un pointeur
 * sur le suivant, et un vers le prcedant.
 *
 * @author  Paul Pinault
 * @version 1.0
 * @date    2003/07/10
 */
public class SLListElement {
    
    /** Objet dans la liste */
    private Object  o;
    /** Pointeur vers le suivant */
    private SLListElement next;
    /** Pointeur vers le prcdant */
    private SLListElement prec;
    
   /** 
    * Creation d'un lment de la liste a partir d'un Objet
    *
    * @param o - l'lement a mmoriser dans la liste
    */
    public SLListElement(Object o) {
        this.o    = o;
        this.next = null;
        this.prec = null;
    }
    
    
   /**
    * Retourne true s'il y a un suivant a cet lment
    *
    * @return true si l'itrateur a d'autres lments
    */
    public boolean haveNext() {
        return ( this.next != null );
    }
    
   /**
    * Retourne l'lment contenu
    *
    * @return L'objet contenu
    */
    public Object getElement() {
        return this.o;
    }
    
   /**
    * Retourne l'lement suivant
    *
    * @return L'lement suivant dans la liste
    */
    public SLListElement getNext() {
        return this.next;
    }

   /**
    * Modifie le lien vers l'lement suivant
    *
    * @param e - Le nouvel lement suivant
    */
    public void setNext(SLListElement e) {
        this.next = e;
    }

   /**
    * Retourne l'lement prcdant
    *
    * @return L'lement prcdant dans la liste
    */
    public SLListElement getPrec() {
        return this.prec;
    }

   /**
    * Modifie le lien vers l'lement prcdant
    *
    * @param e - Le nouvel lement prcdant
    */
    public void setPrec(SLListElement e) {
        this.prec = e;
    }
    
   /**
    * Detruit un lment
    */
    public void clear() {
        this.next = null;
        this.prec = null;
        this.o    = null;
    }
    
    public void finalize() {
        clear();
    }
    
   /**
    * Modifie l'element de l'objet
    */
    public void setElement(Object o) {
        this.o = o;
    }
}
